"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var graphql_1 = require("graphql");
var ScalarType_1 = require("../metadata/ScalarType");
var StringScalar = /** @class */ (function () {
    function StringScalar() {
    }
    return StringScalar;
}());
exports.StringScalar = StringScalar;
var BooleanScalar = /** @class */ (function () {
    function BooleanScalar() {
    }
    return BooleanScalar;
}());
exports.BooleanScalar = BooleanScalar;
var FloatScalar = /** @class */ (function () {
    function FloatScalar() {
    }
    return FloatScalar;
}());
exports.FloatScalar = FloatScalar;
var IntScalar = /** @class */ (function () {
    function IntScalar() {
    }
    return IntScalar;
}());
exports.IntScalar = IntScalar;
var IDScalar = /** @class */ (function () {
    function IDScalar() {
    }
    return IDScalar;
}());
exports.IDScalar = IDScalar;
/**
 * Load all the built in scalar types into a given [[MetadataStorage]].
 * @param storage
 */
function loadBuiltInScalar(storage) {
    storage.register(new ScalarType_1.ScalarType({ typeInstance: graphql_1.GraphQLString }), StringScalar);
    storage.register(new ScalarType_1.ScalarType({ typeInstance: graphql_1.GraphQLBoolean }), BooleanScalar);
    storage.register(new ScalarType_1.ScalarType({ typeInstance: graphql_1.GraphQLFloat }), FloatScalar);
    storage.register(new ScalarType_1.ScalarType({ typeInstance: graphql_1.GraphQLInt }), IntScalar);
    storage.register(new ScalarType_1.ScalarType({ typeInstance: graphql_1.GraphQLID }), IDScalar);
}
exports.loadBuiltInScalar = loadBuiltInScalar;
//# sourceMappingURL=scalar.js.map