/**
 * Decorator for fields resolved from source directly
 * @param fieldName
 */
export declare function source(fieldName?: string): (prototype: {
    $source: any;
}, propertyKey: string) => void;
/**
 * Decorator for field resolved after async fetching
 * prototype should have `$fetch()` method which returns a Promise
 * @param fieldName
 */
export declare function async(fieldName?: string): (prototype: {
    $fetch: () => Promise<any>;
}, propertyKey: string) => void;
