"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var _1 = require(".");
var __1 = require("..");
var Connection = /** @class */ (function (_super) {
    __extends(Connection, _super);
    function Connection(source, args, context, info) {
        var _this = _super.call(this, source, context, info) || this;
        _this.source = source;
        _this.args = args;
        _this.context = context;
        _this.info = info;
        if (args) {
            if (typeof args.first === 'number' && args.first < 0) {
                throw new Error('Argument "first" must be a non-negative integer');
            }
            if (typeof args.last === 'number' && args.last < 0) {
                throw new Error('Argument "last" must be a non-negative integer');
            }
        }
        return _this;
    }
    Connection.getOrCreateEdgesType = function () {
        var _a = this, edgeType = _a.edgeType, nodeType = _a.nodeType;
        if (edgeType) {
            return __1.List.of(edgeType);
        }
        if (nodeType) {
            this.edgeType = /** @class */ (function (_super) {
                __extends(class_1, _super);
                function class_1() {
                    return _super !== null && _super.apply(this, arguments) || this;
                }
                Object.defineProperty(class_1, "nodeType", {
                    get: function () { return nodeType; },
                    enumerable: true,
                    configurable: true
                });
                ;
                return class_1;
            }(_1.Edge));
            Object.defineProperty(this.edgeType, 'name', { value: this.name + "Edge" });
            __1.ObjectType.define()(this.edgeType);
            return __1.List.of(this.edgeType);
        }
        throw new Error('Should provide edgeType or nodeType to Connection subclass');
    };
    var _a, _b, _c;
    Connection = __decorate([
        __1.Definition.define(__1.gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  type Connection {\n    \"\"\"\n    Information to aid in pagination.\n    \"\"\"\n    pageInfo: ", "\n    edges: ", "\n  }\n"], ["\n  type Connection {\n    \"\"\"\n    Information to aid in pagination.\n    \"\"\"\n    pageInfo: ", "\n    edges: ", "\n  }\n"])), _1.PageInfo, function (cls) { return cls.getOrCreateEdgesType(); })),
        __metadata("design:paramtypes", [typeof (_a = typeof TSource !== "undefined" && TSource) === "function" && _a || Object, typeof (_b = typeof TArgs !== "undefined" && TArgs) === "function" && _b || Object, typeof (_c = typeof TContext !== "undefined" && TContext) === "function" && _c || Object, Object])
    ], Connection);
    return Connection;
}(__1.Reducer));
exports.Connection = Connection;
var templateObject_1;
//# sourceMappingURL=Connection.js.map