"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var InputField = /** @class */ (function () {
    function InputField(config) {
        this.config = config;
    }
    Object.defineProperty(InputField.prototype, "defaultName", {
        get: function () { return this.config.defaultName; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputField.prototype, "defaultValue", {
        get: function () { return this.config.defaultValue; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputField.prototype, "description", {
        get: function () { return this.config.description; },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(InputField.prototype, "directives", {
        get: function () { return this.config.directives; },
        enumerable: true,
        configurable: true
    });
    InputField.prototype.buildType = function (storage, targetClass) {
        return this.config.type.buildTypeInstance(storage, targetClass);
    };
    return InputField;
}());
exports.InputField = InputField;
//# sourceMappingURL=InputField.js.map