import { Reducer } from "..";
export interface PageInfoSource {
    hasNextPage?: boolean;
    hasPreviousPage?: boolean;
    startCursor?: string;
    endCursor?: string;
}
export declare class PageInfo extends Reducer<PageInfoSource> {
    hasNextPage: boolean;
    hasPreviousPage: boolean;
    startCursor?: string | null;
    endCursor?: string | null;
}
