"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var __1 = require("..");
var PageInfo = /** @class */ (function (_super) {
    __extends(PageInfo, _super);
    function PageInfo() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    __decorate([
        __1.source(),
        __metadata("design:type", Boolean)
    ], PageInfo.prototype, "hasNextPage", void 0);
    __decorate([
        __1.source(),
        __metadata("design:type", Boolean)
    ], PageInfo.prototype, "hasPreviousPage", void 0);
    __decorate([
        __1.source(),
        __metadata("design:type", Object)
    ], PageInfo.prototype, "startCursor", void 0);
    __decorate([
        __1.source(),
        __metadata("design:type", Object)
    ], PageInfo.prototype, "endCursor", void 0);
    PageInfo = __decorate([
        __1.ObjectType.define(__1.gql(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  \"\"\"\n  Information about pagination in a connection.\n  \"\"\"\n  type PageInfo {\n    \"\"\"When paginating forwards, are there more items?\"\"\"\n    hasNextPage: Boolean!\n\n    \"\"\"When paginating backwards, are there more items?\"\"\"\n    hasPreviousPage: Boolean!\n\n    \"\"\"When paginating backwards, the cursor to continue.\"\"\"\n    startCursor: String\n\n    \"\"\"When paginating forwards, the cursor to continue.\"\"\"\n    endCursor: String\n  }\n"], ["\n  \"\"\"\n  Information about pagination in a connection.\n  \"\"\"\n  type PageInfo {\n    \"\"\"When paginating forwards, are there more items?\"\"\"\n    hasNextPage: Boolean!\n\n    \"\"\"When paginating backwards, are there more items?\"\"\"\n    hasPreviousPage: Boolean!\n\n    \"\"\"When paginating backwards, the cursor to continue.\"\"\"\n    startCursor: String\n\n    \"\"\"When paginating forwards, the cursor to continue.\"\"\"\n    endCursor: String\n  }\n"]))))
    ], PageInfo);
    return PageInfo;
}(__1.Reducer));
exports.PageInfo = PageInfo;
var templateObject_1;
//# sourceMappingURL=PageInfo.js.map