"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var Field = /** @class */ (function () {
    function Field(config) {
        this.config = config;
    }
    Object.defineProperty(Field.prototype, "defaultName", {
        get: function () { return this.config.defaultName; },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(Field.prototype, "description", {
        get: function () { return this.config.description; },
        enumerable: true,
        configurable: true
    });
    ;
    Object.defineProperty(Field.prototype, "deprecationReason", {
        get: function () { return this.config.deprecationReason; },
        enumerable: true,
        configurable: true
    });
    ;
    Field.prototype.buildArgs = function (storage, targetClass) {
        var args = this.config.args;
        return args.reduce(function (args, ref) {
            args[ref.defaultName] = {
                type: ref.buildType(storage, targetClass),
                defaultValue: ref.defaultValue,
                description: ref.description,
            };
            return args;
        }, {});
    };
    Field.prototype.buildType = function (storage, targetClass) {
        return this.config.type.buildTypeInstance(storage, targetClass);
    };
    return Field;
}());
exports.Field = Field;
var FieldMount = /** @class */ (function () {
    function FieldMount(values) {
        Object.assign(this, values);
    }
    return FieldMount;
}());
exports.FieldMount = FieldMount;
//# sourceMappingURL=Field.js.map