import { GraphQLScalarType } from "graphql";
import { Definition, DefinitionConfig } from "../base/Definition";
export interface ScalarTypeConfig extends DefinitionConfig {
    typeInstance: GraphQLScalarType;
}
/**
 * Metadata type for ScalarType
 */
export declare class ScalarType<T extends ScalarTypeConfig = ScalarTypeConfig> extends Definition<T> {
    readonly typeName: string;
    buildTypeInstance(): GraphQLScalarType;
}
